<html>
<head>
<title>OgreHardwareIndexBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreHardwareIndexBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreHardwareIndexBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __HardwareIndexBuffer__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __HardwareIndexBuffer__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBuffer_8h.html">OgreHardwareBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037     <span class="keyword">class </span>HardwareBufferManagerBase;
<a name="l00038"></a>00038 
<a name="l00046"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048         <span class="keyword">public</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">00049</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">IndexType</a> {
<a name="l00050"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326a53907abe886cb9c6ebeb2520733aee4a">00050</a>                 <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326a53907abe886cb9c6ebeb2520733aee4a">IT_16BIT</a>,
<a name="l00051"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326aa5194f6b6d409b1b20f91adf989ef329">00051</a>                 IT_32BIT
<a name="l00052"></a>00052             };
<a name="l00053"></a>00053 
<a name="l00054"></a>00054         <span class="keyword">protected</span>:
<a name="l00055"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#af67b89fb4d762d17da970269bcd9894a">00055</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#af67b89fb4d762d17da970269bcd9894a">mMgr</a>;
<a name="l00056"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#ad55227078ba92018afb29c98a1287eb6">00056</a>             <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">IndexType</a> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#ad55227078ba92018afb29c98a1287eb6">mIndexType</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a8dfffabc8a138184c98227c7ad4fe871">00057</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a8dfffabc8a138184c98227c7ad4fe871">mNumIndexes</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a55901ccfe05b1d3dc65be17174aae6ed">00058</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a55901ccfe05b1d3dc65be17174aae6ed">mIndexSize</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060         <span class="keyword">public</span>:
<a name="l00062"></a>00062             <a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr, <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">IndexType</a> idxType, <span class="keywordtype">size_t</span> numIndexes, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage,
<a name="l00063"></a>00063                 <span class="keywordtype">bool</span> useSystemMemory, <span class="keywordtype">bool</span> useShadowBuffer);
<a name="l00064"></a>00064             ~<a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>();
<a name="l00066"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a7f676fc66c7f4b0c9fc31800d021742e">00066</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a7f676fc66c7f4b0c9fc31800d021742e" title="Return the manager of this buffer, if any.">getManager</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMgr; }
<a name="l00068"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a3f2671fe0ad937070ea24d9bc7626cd3">00068</a>             <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">IndexType</a> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a3f2671fe0ad937070ea24d9bc7626cd3" title="Get the type of indexes used in this buffer.">getType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexType; }
<a name="l00070"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#ab9e775a91b90c6bbac888d97fe51d9d2">00070</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#ab9e775a91b90c6bbac888d97fe51d9d2" title="Get the number of indexes in this buffer.">getNumIndexes</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNumIndexes; }
<a name="l00072"></a><a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a294ab09e6caef25b3c42c277a5de95e1">00072</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a294ab09e6caef25b3c42c277a5de95e1" title="Get the size in bytes of each index.">getIndexSize</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexSize; }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074             <span class="comment">// NB subclasses should override lock, unlock, readData, writeData</span>
<a name="l00075"></a>00075     };
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00079"></a><a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">00079</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;HardwareIndexBuffer&gt;
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081     <span class="keyword">public</span>:
<a name="l00082"></a><a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html#acf8ade5ea73930603152b10379862cdb">00082</a>         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html#acf8ade5ea73930603152b10379862cdb">HardwareIndexBufferSharedPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>&gt;() {}
<a name="l00083"></a>00083         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>* buf);
<a name="l00084"></a>00084     };
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 <span class="preprocessor">#endif</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
